# coding: utf-8

"""
    Wink Payment API

    A programmatic way to create bookings, receive reactive and disburse funds globally.  ## APIs Not every integrator needs every APIs. For that reason, we have separated APIs into context.  - [Affiliate](/affiliate): All APIs related to selling travel inventory as an affiliate. - [Analytics](/analytics): All APIs related to tracking metrics across a wide variety of data source segments including, more entertaining, leaderboard metrics. - [Booking](/booking): All APIs related to creating platform bookings. - [Channel Manager](/channel-manager): All APIs related to channel managers who want to integrate with our platform. - [Extranet](/extranet): All APIs related to managing travel inventory and suppliers. - [Inventory](/inventory): All APIs related to retrieve known travel inventory as it was found using the Lookup API.. - [Lookup](/lookup): All APIs related to locating inventory by region, locale and property flags. - [Reference](/reference): All APIs related to retrieving platform-supported taxonomies. - [TripPay](/reactive): All APIs related to TripPay account management, booking, mapping and integration features.  ## SDKs We are actively working on supporting the most used languages out there. If you don't see your language here, reach out to us with a request to officially add your language. In the meantime, if you want to roll your own SDK, you can do so by downloading the OpenAPI spec and using one of the many available OpenAPI generators available: [https://openapi-generator.tech/docs/generators](https://openapi-generator.tech/docs/generators).  - Java SDK [https://github.com/wink-travel/trip-pay-sdk-java](https://github.com/wink-travel/trip-pay-sdk-java)  # Usage These features are made available to you via a [REST API](https://en.wikipedia.org/wiki/Representational_state_transfer). This API is language agnostic. We will link to SDKs for the most popular programming languages on this page as they become available.  ## Versioning We chose to version our endpoints in a way that we hope affects your integration with us the least. You request the version of our API you wish to work with via the `Wink-Version` header. When it's time for you to upgrade, you only have to change the version number to get access to our updated endpoints.  ## Release history - Follow updates on Github: https://github.com/wink-travel/wink-sdk-java/blob/master/CHANGELOG.md 

    The version of the OpenAPI document: 30.15.2
    Contact: bjorn@wink.travel
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from trip_pay_payment.models.beneficiary_charge import BeneficiaryCharge
from trip_pay_payment.models.pending_refund import PendingRefund
from typing import Optional, Set
from typing_extensions import Self

class Beneficiary(BaseModel):
    """
    Beneficiary is a registered account with rights to compensation within a booking.
    """ # noqa: E501
    account_identifier: StrictStr = Field(description="accountIdentifier of beneficiary that can map to an account with us", alias="accountIdentifier")
    account_name: StrictStr = Field(description="accountName of beneficiary that can map to an account with us", alias="accountName")
    account_email: StrictStr = Field(description="accountEmail of beneficiary that can map to an account with us", alias="accountEmail")
    account_url: Optional[StrictStr] = Field(default=None, description="accountUrl of beneficiary that can map to an account with us", alias="accountUrl")
    type: StrictStr = Field(description="The type of beneficiary payment.")
    amount_due: Optional[BeneficiaryCharge] = Field(default=None, alias="amountDue")
    source_currency: StrictStr = Field(description="The source currency", alias="sourceCurrency")
    display_currency: StrictStr = Field(description="The display currency", alias="displayCurrency")
    supplier_currency: StrictStr = Field(description="The supplier currency", alias="supplierCurrency")
    internal_currency: StrictStr = Field(description="The internal currency", alias="internalCurrency")
    capture_currency: StrictStr = Field(description="The capture currency", alias="captureCurrency")
    source_amount: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="Amount in source currency", alias="sourceAmount")
    display_amount: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="Amount in display currency", alias="displayAmount")
    supplier_amount: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="Amount in supplier currency", alias="supplierAmount")
    internal_amount: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="Amount in internal currency", alias="internalAmount")
    capture_amount: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="Amount in capture currency", alias="captureAmount")
    source_amount_refund_modifier: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="The delta from the original source amount after a refund occurred", alias="sourceAmountRefundModifier")
    display_amount_refund_modifier: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="The delta from the original display amount after a refund occurred", alias="displayAmountRefundModifier")
    supplier_amount_refund_modifier: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="The delta from the original supplier amount after a refund occurred", alias="supplierAmountRefundModifier")
    internal_amount_refund_modifier: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="The delta from the original internal amount after a refund occurred", alias="internalAmountRefundModifier")
    capture_amount_refund_modifier: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="The delta from the original capture amount after a refund occurred", alias="captureAmountRefundModifier")
    pending_refunds: Optional[List[PendingRefund]] = Field(default=None, alias="pendingRefunds")
    net_source_amount: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="Source amount minus source modifier.", alias="netSourceAmount")
    net_display_amount: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="Display amount minus display modifier.", alias="netDisplayAmount")
    net_supplier_amount: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="Supplier amount minus supplier modifier.", alias="netSupplierAmount")
    net_internal_amount: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="Internal amount minus internal modifier.", alias="netInternalAmount")
    net_capture_amount: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="Capture amount minus capture modifier.", alias="netCaptureAmount")
    reconciled: Optional[StrictBool] = Field(default=None, description="Whether a funds transfer has occurred for this booking.")
    metadata: Optional[Dict[str, StrictStr]] = Field(default=None, description="Place to add more data related to the beneficiary.")
    __properties: ClassVar[List[str]] = ["accountIdentifier", "accountName", "accountEmail", "accountUrl", "type", "amountDue", "sourceCurrency", "displayCurrency", "supplierCurrency", "internalCurrency", "captureCurrency", "sourceAmount", "displayAmount", "supplierAmount", "internalAmount", "captureAmount", "sourceAmountRefundModifier", "displayAmountRefundModifier", "supplierAmountRefundModifier", "internalAmountRefundModifier", "captureAmountRefundModifier", "pendingRefunds", "netSourceAmount", "netDisplayAmount", "netSupplierAmount", "netInternalAmount", "netCaptureAmount", "reconciled", "metadata"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['TRIP_PAY', 'PLATFORM_FEE', 'COMMISSION', 'AFFILIATE_AGENCY_FEE', 'SUPPLIER_AGENCY_FEE', 'SALE']):
            raise ValueError("must be one of enum values ('TRIP_PAY', 'PLATFORM_FEE', 'COMMISSION', 'AFFILIATE_AGENCY_FEE', 'SUPPLIER_AGENCY_FEE', 'SALE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Beneficiary from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of amount_due
        if self.amount_due:
            _dict['amountDue'] = self.amount_due.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in pending_refunds (list)
        _items = []
        if self.pending_refunds:
            for _item_pending_refunds in self.pending_refunds:
                if _item_pending_refunds:
                    _items.append(_item_pending_refunds.to_dict())
            _dict['pendingRefunds'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Beneficiary from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountIdentifier": obj.get("accountIdentifier"),
            "accountName": obj.get("accountName"),
            "accountEmail": obj.get("accountEmail"),
            "accountUrl": obj.get("accountUrl"),
            "type": obj.get("type"),
            "amountDue": BeneficiaryCharge.from_dict(obj["amountDue"]) if obj.get("amountDue") is not None else None,
            "sourceCurrency": obj.get("sourceCurrency"),
            "displayCurrency": obj.get("displayCurrency"),
            "supplierCurrency": obj.get("supplierCurrency"),
            "internalCurrency": obj.get("internalCurrency"),
            "captureCurrency": obj.get("captureCurrency"),
            "sourceAmount": obj.get("sourceAmount"),
            "displayAmount": obj.get("displayAmount"),
            "supplierAmount": obj.get("supplierAmount"),
            "internalAmount": obj.get("internalAmount"),
            "captureAmount": obj.get("captureAmount"),
            "sourceAmountRefundModifier": obj.get("sourceAmountRefundModifier"),
            "displayAmountRefundModifier": obj.get("displayAmountRefundModifier"),
            "supplierAmountRefundModifier": obj.get("supplierAmountRefundModifier"),
            "internalAmountRefundModifier": obj.get("internalAmountRefundModifier"),
            "captureAmountRefundModifier": obj.get("captureAmountRefundModifier"),
            "pendingRefunds": [PendingRefund.from_dict(_item) for _item in obj["pendingRefunds"]] if obj.get("pendingRefunds") is not None else None,
            "netSourceAmount": obj.get("netSourceAmount"),
            "netDisplayAmount": obj.get("netDisplayAmount"),
            "netSupplierAmount": obj.get("netSupplierAmount"),
            "netInternalAmount": obj.get("netInternalAmount"),
            "netCaptureAmount": obj.get("netCaptureAmount"),
            "reconciled": obj.get("reconciled"),
            "metadata": obj.get("metadata")
        })
        return _obj


