# coding: utf-8

"""
    Wink Payment API

    A programmatic way to create bookings, receive reactive and disburse funds globally.  ## APIs Not every integrator needs every APIs. For that reason, we have separated APIs into context.  - [Affiliate](/affiliate): All APIs related to selling travel inventory as an affiliate. - [Analytics](/analytics): All APIs related to tracking metrics across a wide variety of data source segments including, more entertaining, leaderboard metrics. - [Booking](/booking): All APIs related to creating platform bookings. - [Channel Manager](/channel-manager): All APIs related to channel managers who want to integrate with our platform. - [Extranet](/extranet): All APIs related to managing travel inventory and suppliers. - [Inventory](/inventory): All APIs related to retrieve known travel inventory as it was found using the Lookup API.. - [Lookup](/lookup): All APIs related to locating inventory by region, locale and property flags. - [Reference](/reference): All APIs related to retrieving platform-supported taxonomies. - [TripPay](/reactive): All APIs related to TripPay account management, booking, mapping and integration features.  ## SDKs We are actively working on supporting the most used languages out there. If you don't see your language here, reach out to us with a request to officially add your language. In the meantime, if you want to roll your own SDK, you can do so by downloading the OpenAPI spec and using one of the many available OpenAPI generators available: [https://openapi-generator.tech/docs/generators](https://openapi-generator.tech/docs/generators).  - Java SDK [https://github.com/wink-travel/trip-pay-sdk-java](https://github.com/wink-travel/trip-pay-sdk-java)  # Usage These features are made available to you via a [REST API](https://en.wikipedia.org/wiki/Representational_state_transfer). This API is language agnostic. We will link to SDKs for the most popular programming languages on this page as they become available.  ## Versioning We chose to version our endpoints in a way that we hope affects your integration with us the least. You request the version of our API you wish to work with via the `Wink-Version` header. When it's time for you to upgrade, you only have to change the version number to get access to our updated endpoints.  ## Release history - Follow updates on Github: https://github.com/wink-travel/wink-sdk-java/blob/master/CHANGELOG.md 

    The version of the OpenAPI document: 30.15.2
    Contact: bjorn@wink.travel
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from trip_pay_payment.models.contact import Contact
from trip_pay_payment.models.pet_info_dto import PetInfoDto
from typing import Optional, Set
from typing_extensions import Self

class Personal(BaseModel):
    """
    Detailed customer information for this profile
    """ # noqa: E501
    gender: Optional[StrictStr] = Field(default=None, description="Identifier the gender of the customer.")
    birth_date: Optional[date] = Field(default=None, description="Indicates the date of birth as indicated in the document, in ISO 8601 prescribed format.", alias="birthDate")
    marital_status: Optional[StrictStr] = Field(default=None, description="Marital status of the traveler.", alias="maritalStatus")
    child_quantity: Optional[StrictInt] = Field(default=None, description="The number of children of the customer.", alias="childQuantity")
    citizenship: Optional[StrictStr] = Field(default=None, description="Name of the (self-professed) country that is clamided for citizenship.")
    address1: Optional[StrictStr] = Field(default=None, description="Address line 1")
    address2: Optional[StrictStr] = Field(default=None, description="Address line 2")
    city: Optional[StrictStr] = Field(default=None, description="City")
    state: Optional[StrictStr] = Field(default=None, description="State")
    postal_code: Optional[StrictStr] = Field(default=None, description="Postal code", alias="postalCode")
    country: Optional[StrictStr] = Field(default=None, description="Country")
    preferred_currency: Optional[StrictStr] = Field(default=None, description="Type of funds preferred for reviewing monetary values, in ISO 4217 codes", alias="preferredCurrency")
    language: Optional[StrictStr] = Field(default=None, description="The primary language of the customer")
    contact_person: Optional[List[Contact]] = Field(default=None, alias="contactPerson")
    phys_chall_name: Optional[List[StrictStr]] = Field(default=None, alias="physChallName")
    pet_info: Optional[List[PetInfoDto]] = Field(default=None, alias="petInfo")
    __properties: ClassVar[List[str]] = ["gender", "birthDate", "maritalStatus", "childQuantity", "citizenship", "address1", "address2", "city", "state", "postalCode", "country", "preferredCurrency", "language", "contactPerson", "physChallName", "petInfo"]

    @field_validator('gender')
    def gender_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['MALE', 'FEMALE', 'OTHER']):
            raise ValueError("must be one of enum values ('MALE', 'FEMALE', 'OTHER')")
        return value

    @field_validator('marital_status')
    def marital_status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['ANNULLED', 'COHABITATING', 'DIVORCED', 'ENGAGED', 'MARRIED', 'SEPARATED', 'SINGLE', 'WIDOWED', 'UNKNOWN']):
            raise ValueError("must be one of enum values ('ANNULLED', 'COHABITATING', 'DIVORCED', 'ENGAGED', 'MARRIED', 'SEPARATED', 'SINGLE', 'WIDOWED', 'UNKNOWN')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Personal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in contact_person (list)
        _items = []
        if self.contact_person:
            for _item_contact_person in self.contact_person:
                if _item_contact_person:
                    _items.append(_item_contact_person.to_dict())
            _dict['contactPerson'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in pet_info (list)
        _items = []
        if self.pet_info:
            for _item_pet_info in self.pet_info:
                if _item_pet_info:
                    _items.append(_item_pet_info.to_dict())
            _dict['petInfo'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Personal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "gender": obj.get("gender"),
            "birthDate": obj.get("birthDate"),
            "maritalStatus": obj.get("maritalStatus"),
            "childQuantity": obj.get("childQuantity"),
            "citizenship": obj.get("citizenship"),
            "address1": obj.get("address1"),
            "address2": obj.get("address2"),
            "city": obj.get("city"),
            "state": obj.get("state"),
            "postalCode": obj.get("postalCode"),
            "country": obj.get("country"),
            "preferredCurrency": obj.get("preferredCurrency"),
            "language": obj.get("language"),
            "contactPerson": [Contact.from_dict(_item) for _item in obj["contactPerson"]] if obj.get("contactPerson") is not None else None,
            "physChallName": obj.get("physChallName"),
            "petInfo": [PetInfoDto.from_dict(_item) for _item in obj["petInfo"]] if obj.get("petInfo") is not None else None
        })
        return _obj


