# coding: utf-8

"""
    Wink Payment API

    A programmatic way to create bookings, receive reactive and disburse funds globally.  ## APIs Not every integrator needs every APIs. For that reason, we have separated APIs into context.  - [Affiliate](/affiliate): All APIs related to selling travel inventory as an affiliate. - [Analytics](/analytics): All APIs related to tracking metrics across a wide variety of data source segments including, more entertaining, leaderboard metrics. - [Booking](/booking): All APIs related to creating platform bookings. - [Channel Manager](/channel-manager): All APIs related to channel managers who want to integrate with our platform. - [Extranet](/extranet): All APIs related to managing travel inventory and suppliers. - [Inventory](/inventory): All APIs related to retrieve known travel inventory as it was found using the Lookup API.. - [Lookup](/lookup): All APIs related to locating inventory by region, locale and property flags. - [Reference](/reference): All APIs related to retrieving platform-supported taxonomies. - [TripPay](/reactive): All APIs related to TripPay account management, booking, mapping and integration features.  ## SDKs We are actively working on supporting the most used languages out there. If you don't see your language here, reach out to us with a request to officially add your language. In the meantime, if you want to roll your own SDK, you can do so by downloading the OpenAPI spec and using one of the many available OpenAPI generators available: [https://openapi-generator.tech/docs/generators](https://openapi-generator.tech/docs/generators).  - Java SDK [https://github.com/wink-travel/trip-pay-sdk-java](https://github.com/wink-travel/trip-pay-sdk-java)  # Usage These features are made available to you via a [REST API](https://en.wikipedia.org/wiki/Representational_state_transfer). This API is language agnostic. We will link to SDKs for the most popular programming languages on this page as they become available.  ## Versioning We chose to version our endpoints in a way that we hope affects your integration with us the least. You request the version of our API you wish to work with via the `Wink-Version` header. When it's time for you to upgrade, you only have to change the version number to get access to our updated endpoints.  ## Release history - Follow updates on Github: https://github.com/wink-travel/wink-sdk-java/blob/master/CHANGELOG.md 

    The version of the OpenAPI document: 30.15.2
    Contact: bjorn@wink.travel
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Preferences(BaseModel):
    """
    Customer preferences
    """ # noqa: E501
    property_location_pref: Optional[StrictStr] = Field(default=None, description="Indicates preference for hotel property locations.", alias="propertyLocationPref")
    property_type_pref: Optional[StrictStr] = Field(default=None, description="Indicates preference for hotel property types.", alias="propertyTypePref")
    hotel_chain_pref: Optional[StrictStr] = Field(default=None, description="Identifies a preferred company by name.", alias="hotelChainPref")
    property_amenity_pref: Optional[List[StrictStr]] = Field(default=None, description="Indicates preferences for hotel property amenities.", alias="propertyAmenityPref")
    recreation_srvc_pref: Optional[List[StrictStr]] = Field(default=None, description="Indicates preference for the type of recreation services in a hotel", alias="recreationSrvcPref")
    business_srvc_pref: Optional[List[StrictStr]] = Field(default=None, description="Indicates preference for type of business services in a hotel", alias="businessSrvcPref")
    security_feature_pref: Optional[List[StrictStr]] = Field(default=None, description="Indicates preference of rtype of security features in a hotel", alias="securityFeaturePref")
    phys_chal_feature_pref: Optional[List[StrictStr]] = Field(default=None, description="Indicates preferences for type of features required to meet the needs of persons with physical challenges, disabilities, etc.", alias="physChalFeaturePref")
    smoking_allowed: Optional[StrictBool] = Field(default=None, description="Indicates preference for smooking allowed rooms..", alias="smokingAllowed")
    room_location_pref: Optional[StrictStr] = Field(default=None, description="Indicates preference for hotel room locations.", alias="roomLocationPref")
    bed_type_pref: Optional[StrictStr] = Field(default=None, description="Indicates preferences for the size and features of hotel bed types.", alias="bedTypePref")
    food_srvc_pref: Optional[StrictStr] = Field(default=None, description="Indicates preferences for type of food listener facilities in a hotel.", alias="foodSrvcPref")
    room_amenity_pref: Optional[List[StrictStr]] = Field(default=None, description="Indicates preferences for hotel room amenities.", alias="roomAmenityPref")
    guest_type: Optional[StrictStr] = Field(default=None, description="Guest type", alias="guestType")
    meal_pref: Optional[StrictStr] = Field(default=None, description="Indicates meal preference.", alias="mealPref")
    cuisine_pref: Optional[StrictStr] = Field(default=None, description="Indicates cuisine preference.", alias="cuisinePref")
    interest_pref: Optional[List[StrictStr]] = Field(default=None, description="Indicates interest preference", alias="interestPref")
    beverage_pref: Optional[List[StrictStr]] = Field(default=None, description="Indicates beverage preference.", alias="beveragePref")
    food_pref: Optional[List[StrictStr]] = Field(default=None, description="Indicates food preference.", alias="foodPref")
    allergies: Optional[List[StrictStr]] = Field(default=None, description="Indicates allergies")
    pets_pref: Optional[List[StrictStr]] = Field(default=None, description="Indicates pet preferences", alias="petsPref")
    __properties: ClassVar[List[str]] = ["propertyLocationPref", "propertyTypePref", "hotelChainPref", "propertyAmenityPref", "recreationSrvcPref", "businessSrvcPref", "securityFeaturePref", "physChalFeaturePref", "smokingAllowed", "roomLocationPref", "bedTypePref", "foodSrvcPref", "roomAmenityPref", "guestType", "mealPref", "cuisinePref", "interestPref", "beveragePref", "foodPref", "allergies", "petsPref"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Preferences from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Preferences from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "propertyLocationPref": obj.get("propertyLocationPref"),
            "propertyTypePref": obj.get("propertyTypePref"),
            "hotelChainPref": obj.get("hotelChainPref"),
            "propertyAmenityPref": obj.get("propertyAmenityPref"),
            "recreationSrvcPref": obj.get("recreationSrvcPref"),
            "businessSrvcPref": obj.get("businessSrvcPref"),
            "securityFeaturePref": obj.get("securityFeaturePref"),
            "physChalFeaturePref": obj.get("physChalFeaturePref"),
            "smokingAllowed": obj.get("smokingAllowed"),
            "roomLocationPref": obj.get("roomLocationPref"),
            "bedTypePref": obj.get("bedTypePref"),
            "foodSrvcPref": obj.get("foodSrvcPref"),
            "roomAmenityPref": obj.get("roomAmenityPref"),
            "guestType": obj.get("guestType"),
            "mealPref": obj.get("mealPref"),
            "cuisinePref": obj.get("cuisinePref"),
            "interestPref": obj.get("interestPref"),
            "beveragePref": obj.get("beveragePref"),
            "foodPref": obj.get("foodPref"),
            "allergies": obj.get("allergies"),
            "petsPref": obj.get("petsPref")
        })
        return _obj


