# coding: utf-8

"""
    Wink Payment API

    A programmatic way to create bookings, receive reactive and disburse funds globally.  ## APIs Not every integrator needs every APIs. For that reason, we have separated APIs into context.  - [Affiliate](/affiliate): All APIs related to selling travel inventory as an affiliate. - [Analytics](/analytics): All APIs related to tracking metrics across a wide variety of data source segments including, more entertaining, leaderboard metrics. - [Booking](/booking): All APIs related to creating platform bookings. - [Channel Manager](/channel-manager): All APIs related to channel managers who want to integrate with our platform. - [Extranet](/extranet): All APIs related to managing travel inventory and suppliers. - [Inventory](/inventory): All APIs related to retrieve known travel inventory as it was found using the Lookup API.. - [Lookup](/lookup): All APIs related to locating inventory by region, locale and property flags. - [Reference](/reference): All APIs related to retrieving platform-supported taxonomies. - [TripPay](/reactive): All APIs related to TripPay account management, booking, mapping and integration features.  ## SDKs We are actively working on supporting the most used languages out there. If you don't see your language here, reach out to us with a request to officially add your language. In the meantime, if you want to roll your own SDK, you can do so by downloading the OpenAPI spec and using one of the many available OpenAPI generators available: [https://openapi-generator.tech/docs/generators](https://openapi-generator.tech/docs/generators).  - Java SDK [https://github.com/wink-travel/trip-pay-sdk-java](https://github.com/wink-travel/trip-pay-sdk-java)  # Usage These features are made available to you via a [REST API](https://en.wikipedia.org/wiki/Representational_state_transfer). This API is language agnostic. We will link to SDKs for the most popular programming languages on this page as they become available.  ## Versioning We chose to version our endpoints in a way that we hope affects your integration with us the least. You request the version of our API you wish to work with via the `Wink-Version` header. When it's time for you to upgrade, you only have to change the version number to get access to our updated endpoints.  ## Release history - Follow updates on Github: https://github.com/wink-travel/wink-sdk-java/blob/master/CHANGELOG.md 

    The version of the OpenAPI document: 30.15.2
    Contact: bjorn@wink.travel
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SupplierContractItemPolicy(BaseModel):
    """
    Outlines the policy for this item.
    """ # noqa: E501
    refundable: StrictBool = Field(description="Whether this booking is refundable or not.")
    advance_cancellation_free_of_charge: Optional[StrictStr] = Field(default=None, description="When the cancellation policy is refundable, this flag can be set and indicates there is more rules involved than just a no-questions-asked refundable.", alias="advanceCancellationFreeOfCharge")
    refundable_cancellation_charge: Optional[StrictStr] = Field(default=None, description="If advanceCancellationFreeOfCharge rules is not honored, this property explains what the guest will be charged.", alias="refundableCancellationCharge")
    no_show_charge: Optional[StrictStr] = Field(default=None, description="In case the 'Refundable cancellation charge' is set, a different no show charge can be applied.", alias="noShowCharge")
    non_refundable_cancellation_charge: Optional[StrictStr] = Field(default=None, description="When the cancellation policy is non-refundable, this flag can be set and indicates there is more rules involved to calculate what the guest will owe in case of a cancellation.", alias="nonRefundableCancellationCharge")
    non_refundable_deadline: Optional[StrictStr] = Field(default=None, description="The non-refundable charge might can have a deadline. If that deadline passes, the guest might be charged more.", alias="nonRefundableDeadline")
    non_refundable_after_deadline_cancellation_charge: Optional[StrictStr] = Field(default=None, description="If the guest does not honor the non-refundable deadline rule, this charge dictates what she owes after the deadline passes.", alias="nonRefundableAfterDeadlineCancellationCharge")
    external_identifier: Optional[StrictStr] = Field(default=None, description="Optional geoname externalIdentifier to remote policy.", alias="externalIdentifier")
    fully_refundable: Optional[StrictBool] = Field(default=None, alias="fullyRefundable")
    partially_refundable: Optional[StrictBool] = Field(default=None, alias="partiallyRefundable")
    __properties: ClassVar[List[str]] = ["refundable", "advanceCancellationFreeOfCharge", "refundableCancellationCharge", "noShowCharge", "nonRefundableCancellationCharge", "nonRefundableDeadline", "nonRefundableAfterDeadlineCancellationCharge", "externalIdentifier", "fullyRefundable", "partiallyRefundable"]

    @field_validator('advance_cancellation_free_of_charge')
    def advance_cancellation_free_of_charge_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['UNTIL_EIGHTEEN_HUNDRED_HOURS_ON_DAY_OF_ARRIVAL', 'UNTIL_FOURTEEN_HUNDRED_HOURS_ON_DAY_OF_ARRIVAL', 'ONE_DAY_BEFORE_ARRIVAL', 'TWO_DAYS_BEFORE_ARRIVAL', 'THREE_DAYS_BEFORE_ARRIVAL', 'FIVE_DAYS_BEFORE_ARRIVAL', 'SEVEN_DAYS_BEFORE_ARRIVAL', 'FOURTEEN_DAYS_BEFORE_ARRIVAL', 'TWENTYONE_DAYS_BEFORE_ARRIVAL', 'THIRTY_DAYS_BEFORE_ARRIVAL', 'FOURTY_TWO_DAYS_BEFORE_ARRIVAL', 'SIXTY_DAYS_BEFORE_ARRIVAL']):
            raise ValueError("must be one of enum values ('UNTIL_EIGHTEEN_HUNDRED_HOURS_ON_DAY_OF_ARRIVAL', 'UNTIL_FOURTEEN_HUNDRED_HOURS_ON_DAY_OF_ARRIVAL', 'ONE_DAY_BEFORE_ARRIVAL', 'TWO_DAYS_BEFORE_ARRIVAL', 'THREE_DAYS_BEFORE_ARRIVAL', 'FIVE_DAYS_BEFORE_ARRIVAL', 'SEVEN_DAYS_BEFORE_ARRIVAL', 'FOURTEEN_DAYS_BEFORE_ARRIVAL', 'TWENTYONE_DAYS_BEFORE_ARRIVAL', 'THIRTY_DAYS_BEFORE_ARRIVAL', 'FOURTY_TWO_DAYS_BEFORE_ARRIVAL', 'SIXTY_DAYS_BEFORE_ARRIVAL')")
        return value

    @field_validator('refundable_cancellation_charge')
    def refundable_cancellation_charge_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['FIRST_NIGHT', 'THIRTY_PERCENT', 'FIFTY_PERCENT', 'SIXTY_PERCENT', 'SEVENTY_PERCENT', 'NINENTY_PERCENT', 'ONE_HUNDRED_PERCENT']):
            raise ValueError("must be one of enum values ('FIRST_NIGHT', 'THIRTY_PERCENT', 'FIFTY_PERCENT', 'SIXTY_PERCENT', 'SEVENTY_PERCENT', 'NINENTY_PERCENT', 'ONE_HUNDRED_PERCENT')")
        return value

    @field_validator('no_show_charge')
    def no_show_charge_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['SAME_AS_CANCELLATION_FEE', 'ONE_HUNDRED_PERCENT_OF_TOTAL_CHARGE']):
            raise ValueError("must be one of enum values ('SAME_AS_CANCELLATION_FEE', 'ONE_HUNDRED_PERCENT_OF_TOTAL_CHARGE')")
        return value

    @field_validator('non_refundable_cancellation_charge')
    def non_refundable_cancellation_charge_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['FIRST_NIGHT', 'TEN_PERCENT', 'THIRTY_PERCENT', 'FIFTY_PERCENT', 'SEVENTY_PERCENT']):
            raise ValueError("must be one of enum values ('FIRST_NIGHT', 'TEN_PERCENT', 'THIRTY_PERCENT', 'FIFTY_PERCENT', 'SEVENTY_PERCENT')")
        return value

    @field_validator('non_refundable_deadline')
    def non_refundable_deadline_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['ONE_DAY_BEFORE_ARRIVAL', 'TWO_DAYS_BEFORE_ARRIVAL', 'THREE_DAYS_BEFORE_ARRIVAL', 'FIVE_DAYS_BEFORE_ARRIVAL', 'SEVEN_DAYS_BEFORE_ARRIVAL', 'FOURTEEN_DAYS_BEFORE_ARRIVAL', 'TWENTYONE_DAYS_BEFORE_ARRIVAL', 'THIRTY_DAYS_BEFORE_ARRIVAL', 'FOURTY_TWO_DAYS_BEFORE_ARRIVAL', 'SIXTY_DAYS_BEFORE_ARRIVAL']):
            raise ValueError("must be one of enum values ('ONE_DAY_BEFORE_ARRIVAL', 'TWO_DAYS_BEFORE_ARRIVAL', 'THREE_DAYS_BEFORE_ARRIVAL', 'FIVE_DAYS_BEFORE_ARRIVAL', 'SEVEN_DAYS_BEFORE_ARRIVAL', 'FOURTEEN_DAYS_BEFORE_ARRIVAL', 'TWENTYONE_DAYS_BEFORE_ARRIVAL', 'THIRTY_DAYS_BEFORE_ARRIVAL', 'FOURTY_TWO_DAYS_BEFORE_ARRIVAL', 'SIXTY_DAYS_BEFORE_ARRIVAL')")
        return value

    @field_validator('non_refundable_after_deadline_cancellation_charge')
    def non_refundable_after_deadline_cancellation_charge_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['FIRST_NIGHT', 'TEN_PERCENT', 'THIRTY_PERCENT', 'FIFTY_PERCENT', 'SEVENTY_PERCENT', 'ONE_HUNDRED_PERCENT']):
            raise ValueError("must be one of enum values ('FIRST_NIGHT', 'TEN_PERCENT', 'THIRTY_PERCENT', 'FIFTY_PERCENT', 'SEVENTY_PERCENT', 'ONE_HUNDRED_PERCENT')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SupplierContractItemPolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "fully_refundable",
            "partially_refundable",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SupplierContractItemPolicy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "refundable": obj.get("refundable"),
            "advanceCancellationFreeOfCharge": obj.get("advanceCancellationFreeOfCharge"),
            "refundableCancellationCharge": obj.get("refundableCancellationCharge"),
            "noShowCharge": obj.get("noShowCharge"),
            "nonRefundableCancellationCharge": obj.get("nonRefundableCancellationCharge"),
            "nonRefundableDeadline": obj.get("nonRefundableDeadline"),
            "nonRefundableAfterDeadlineCancellationCharge": obj.get("nonRefundableAfterDeadlineCancellationCharge"),
            "externalIdentifier": obj.get("externalIdentifier"),
            "fullyRefundable": obj.get("fullyRefundable"),
            "partiallyRefundable": obj.get("partiallyRefundable")
        })
        return _obj


